from selenium import webdriver
import time


#Universe ID to add (as a string).
universeId = str(0)

#List of sound IDs to set permissions for (as an array of integers)
soundIds = []

#Intervals for waiting for load (waiting arbitrary lengths for load is generally a terible idea - this is quick non-production code so idc)
sleepInterval = 0.2
longerSleepInterval = 1

# Page load error message.
timeOutMessage = "This item can't be configured right now. Please try again later."
errorTimeout = 10

# Types the uiverse ID into the text box.
def TypeUniverseId():
    universeTextBox = browser.find_element_by_id("universe-ids")
    universeTextBox.send_keys(universeId)
    universeButton = browser.find_element_by_id("provide-access-button")
    universeButton.click()

# Checks if the table of expereinces contains the given one.
def HasUniverseId():
    universeTable = browser.find_elements_by_tag_name("table")
    for uni in universeTable:
        if universeId in uni.text:
            return True
    return False

# Presses the save page button
def SavePage():
    saveButton = browser.find_element_by_id("submit-button")
    saveButton.click()

# Retruns true if the page had loaded (once the universe text box has appeared)
def PageLoaded():
    try:
        new_page = browser.find_element_by_id("universe-ids")
        return True
    except:
        return False

# Detects if the page error messgae timeout has occured.
def PageError():
    if timeOutMessage in browser.find_element_by_tag_name("body").text:
        return True
    else:
        return False

# Load the page and check timeout message not occured, if so reload.
def LoadPage(url):
    browser.get(browserURL)
    while PageError():
        print("Timeout")
        time.sleep(errorTimeout)
        browser.get(browserURL)

    while not PageLoaded():
        time.sleep(sleepInterval)
        if PageError():
            print("Timeout")
            time.sleep(errorTimeout)
            browser.get(browserURL)

# Check if we can add a place ID or not (this will probabbly be messed up in future updates once radio-boxs for all/specific expereinces are enabled).
def IsTextboxDisabled():
    universeTextbox = browser.find_element_by_id("universe-ids")
    if universeTextbox.get_attribute("disabled") == "true":
        return True
    return False

#Start 
browser = webdriver.Chrome()

#Wait for log in (press return in terminal once logged in via the browser).
browser.get("https://www.roblox.com/Login")
input("Please login. Remember to make full-screen.\n")

currentSound = 0

# Loop over each sound.
while currentSound < len(soundIds):
    browserURL = "https://www.roblox.com/library/configure?id=" + str(soundIds[currentSound]) + "#!/general"
    print("Changing", browserURL)

    try:
        # Load Page
        LoadPage(browserURL)
        time.sleep(longerSleepInterval)

        # If can't edit then skip.
        if IsTextboxDisabled():
            currentSound += 1
            print("Permission can't be changed.")
            continue

        # Add Universe
        TypeUniverseId()

        # Save
        time.sleep(sleepInterval)
        SavePage()
        time.sleep(longerSleepInterval)

        #Reload Page and check universe added
        LoadPage(browserURL)

        # Check universe added, only progress to next once read confirmed.
        time.sleep(longerSleepInterval)
        if HasUniverseId():
            currentSound += 1
            print("Permission Added.")
        else:
            print("Permission not Added,  Trying Again.")
    except:
        print("Error Occured, Trying Again")

    # input("Change Next\n")

print("Finished.")